#!/bin/bash

set -e

#TODO: 1. Karte gewünscht: Orte der Kindheits-, Schul- und Studienzeit (Haardt bei Neu-
#stadt, Kirchheim an der Eck, Bibelheim, Grünstadt, Heidelberg, Speyer, Frankenthal, Ostho-
#fen, Mainz, Alzey, Amorbach, Weinheim, Erbach, Rimbach)

#GMT makecpt -Csemigray.cpt -Z -T0/8000/100 > height.cpt

output=isaak_karte_1
range="-R7.75/9.43/49.25/50.05"
proj="-JM14c"
common="$range $proj -P -V --HISTORY=FALSE"
GMT grdimage topo/height.grd -Cheight.cpt -E300 $common -K > $output.ps
common="$common -O"
GMT pscoast $common -Df -S255 -W.6pt,100 -Ir/.6pt,100 -K >> $output.ps
towns="
8.138333 49.366111 9 0 29 RB Haardt bei Neustadt
8.180833 49.537222 9 0 29 RB Kirchheim an der Eck
8.170556 49.796667 9 0 29 LB Biebelnheim
8.168056 49.569167 9 0 29 LB Gr\374nstadt
8.71 49.412222 9 0 29 RT Heidelberg
8.431111 49.319444 9 0 29 RB Speyer
8.35 49.533333 9 0 29 RT Frankenthal
8.328889 49.707778 9 0 29 RB Osthofen
8.271111 50 9 0 29 LB Mainz
8.116111 49.751667 9 0 29 LB Alzey
9.21899 49.643261 9 0 29 LB Amorbach
8.669722 49.556111 9 0 29 LB Weinheim
8.995833 49.658333 9 0 29 LB Erbach
8.76 49.623333 9 0 29 LB Rimbach
"
echo "$towns" | GMT psxy $common -K -Sc2p -G50  >> $output.ps
echo "$towns" | GMT pstext $common -K -Dj1.5p/1.5p  >> $output.ps
GMT psbasemap $common -Bp --BASEMAP_TYPE=plain >> $output.ps
GMT ps2raster $output.ps -Tf -V -A
rm -f $output.ps

#TODO: 2. Karte gewünscht: Orte des beruflichen und familiären Wirkens in Baden (Diers-
#burg, Offenburg, Karlsruhe, Kieselbronn, Pforzheim, Grötzingen, Würm, Eutingen)

output=isaak_karte_2
range="-R7.8/9/48.4/49.05"
proj="-JM14c"
common="$range $proj -P -V --HISTORY=FALSE"
#GMT makecpt -Csemigray.cpt -Z -T0/3000/100 > height.cpt
GMT grdimage topo/height.grd -Cheight.cpt -E300 $common -K > $output.ps
common="$common -O"
GMT pscoast $common -Df -S255 -W.6pt,100 -Ir/.6pt,100 -K >> $output.ps
towns="
8.073889 48.631389 9 0 29 LB Achern
 7.908333 48.423889 9 0 29 LB Diersburg
 7.940833 48.470833 9 0 29 LB Offenburg
 8.4043 49.014 9 0 29 LB Karlsruhe
 8.748611 48.933333 9 0 29 LB Kieselbronn
 8.716667 48.9 9 0 29 LT Pforzheim
 8.495556 49.009444 9 0 29 LT Gr\366tzingen
 8.7375 48.8589 9 0 29 LB W\374rm
 8.745938 48.910855 9 0 29 LB Eutingen
 8.084757 48.624981 9 0 29 LT Heil und Pflegeanstalt Illenau
"
echo "$towns" | GMT psxy $common -K -Sc2p -G50  >> $output.ps
echo "$towns" | GMT pstext $common -K -Dj1.5p/1.5p  >> $output.ps
GMT psbasemap $common -Bp --BASEMAP_TYPE=plain >> $output.ps
GMT ps2raster $output.ps -Tf -V -A
rm -f $output.ps

#TODO: 3. Karte gewünscht:
#Reisen in den 1850er Jahren in Südwest-und Mitteldeutschland: Leipzig, Herrnhut, Dresden (Pforzheim, Leipzig, Herrnhut, Weinheim, Heidelberg, Dresden, Elbtal, böhmische Grenze, Halle, Frankfurt, Gießen, Marburg, Guntershausen, Eisenach, Bamberg, Nürnberg, Salzburg, Königsee, Taunus, Ems, Koblenz, Neuwied, Mannheim, Sulzfeld)

output=isaak_karte_3
range="-R6.8/15/47.45/51.55"
proj="-JM14c"
common="$range $proj -P -V --HISTORY=FALSE"
#GMT makecpt -Csemigray.cpt -Z -T0/3000/100 > height.cpt
GMT grdimage topo/height.grd -Cheight.cpt -E300 $common -K > $output.ps
common="$common -O"
GMT pscoast $common -Df -S255 -W.6pt,100 -Ir/.6pt,100 -K >> $output.ps
towns="
8.716667 48.9 9 0 29 LB Pforzheim
12.37475 51.340333 9 0 29 LT Leipzig
14.741667 51.016667 9 0 29 RB Herrnhut
8.669722 49.556111 9 0 29 LB Weinheim
8.71 49.412222 9 0 29 LB Heidelberg
13.73836 51.049259 9 0 29 RB Dresden
14.079849 50.957274 9 0 29 RM Elbtal
14.236944 50.874167 9 0 29 RT b\366hmische Grenze
11.97 51.482778 9 0 29 LT Halle
8.685944 50.111806 9 0 29 LB Frankfurt
8.666667 50.583333 9 0 29 LB Gie\337en
8.766667 50.816667 9 0 29 LB Marburg
9.416272 51.258439 9 0 29 RB Guntershausen
10.324556 50.974583 9 0 29 LB Eisenach
10.891667 49.891667 9 0 29 LB Bamberg
11.077778 49.452778 9 0 29 LB N\374rnberg
13.033333 47.8 9 0 29 LB Salzburg
12.977778 47.553889 9 0 29 LM K\366nigsee
8.068556 50.141444 9 0 29 RT Taunus
7.710556 50.338056 9 0 29 LT Bad Ems
7.593889 50.356667 9 0 29 RT Koblenz
7.461389 50.428611 9 0 29 LB Neuwied
8.463056 49.483611 9 0 29 RB Mannheim
8.855 49.103333 9 0 29 RB Sulzfeld
9.1775 48.776111 9 0 29 LT Stuttgart
13.004167 47.631389 9 0 29 LB Berchtesgaden
7.671944 47.801667 9 0 29 LT Badenweiler
#8.200833 48.598056 9 0 29 LT Mummelsee
8.2025 48.606944 9 0 29 LT Hornisgrinde
11.574444 48.139722 9 0 29 LT M\374nchen
11.392778 47.267222 9 0 29 LT Innsbruck
11.337222 47.646111 9 0 29 LB Kochelsee
11.346111 47.593889 9 0 29 LM Walchensee
"
echo "$towns" | GMT psxy $common -K -Sc2p -G50  >> $output.ps
echo "$towns" | GMT pstext $common -K -Dj1.5p/1.5p  >> $output.ps
GMT psbasemap $common -Bp --BASEMAP_TYPE=plain >> $output.ps
GMT ps2raster $output.ps -Tf -V -A
rm -f $output.ps


#TODO: 4. Karte gewünscht: 
#Reisen in die Schweiz (
# 1958: Bern, Interlaken, Lauterbrunnen, Mürren, Grindelwald, Meiringen, Brünig, Luzern, Rigi, Zürch, Ulm, Ludwigsburg, Korntal, Heilbronn, Heidelberg, Sulzfeld.
#1860: Basel, Zürch, Rigi, Luzern, Bern, Interlaken, Gießbach, Bern, St. Gallen, Überlingen, Ludwigsburg, Pforzheim.
#1862: Vierwaldstätter See.
#1864: Genf. Neuchateler See. Interlaken, Grindelwald, Mürren, Meiringen, Brünigpass, Zürch. Zürch, Horgen, Rigi, Goldau.
#1860: Rigi.
#1870: Basel, Solothurn, Weißenstein, Gensburg, Olten, Basel
# von Irene hinzugefügt: Montreux, Martigny, Chamonix, und Lausanne,


output=isaak_karte_4
range="-R6.1/9.55/45.9/47.6"
proj="-JM14c"
common="$range $proj -P -V --HISTORY=FALSE"
#GMT makecpt -Csemigray.cpt -Z -T0/6000/100 > height.cpt
GMT grdimage topo/height.grd -Cheight.cpt -E300 $common -K > $output.ps
common="$common -O"
GMT pscoast $common -Df -S255 -W.6pt,100 -Ir/.6pt,100 -K >> $output.ps
towns="
7.438637 46.951081 9 0 29 LB Bern
7.86666 46.683331 9 0 29 RT Interlaken
7.908887 46.599991 9 0 29 LT Lauterbrunnen
7.892222 46.559444 9 0 29 RT M\374rren
8.033339 46.625829 9 0 29 LM Grindelwald
8.186384 46.728606 9 0 29 LT Meiringen
8.137778 46.757778 9 0 29 LB Br\374nig
8.3 47.05 9 0 29 RT Luzern
8.475556 47.053611 9 0 29 RB Rigi
8.541001 47.379022 9 0 29 LB Z\374rich
# 1860
7.591127 47.550558 9 0 29 RT Basel
#8.541001 47.379022 9 0 29 LB Z\374rch
#8.475556 47.053611 9 0 29 LB Rigi
#8.3 47.05 9 0 29 CB Luzern
#7.438637 46.951081 9 0 29 LB Bern
#7.86666 46.683331 9 0 29 LB Interlaken
8.020556 46.735278 9 0 29 RB Gie\337bach
#7.438637 46.951081 9 0 29 LB Bern
9.377225 47.423336 9 0 29 RT St. Gallen
#9.158333 47.766667 9 0 29 RT \334berlingen
#9.1922 48.8975 9 0 29 LB Ludwigsburg
8.716667 48.9 9 0 29 RB Pforzheim
# 1862
8.401111 47.019444 9 0 29 LT Vierwaldst\344tter See
#1864:
6.149985 46.200013 9 0 29 LB Genf
6.930567 46.990281 9 0 29 RB Neuch\342tel
#7.86666 46.683331 9 0 29 LB Interlaken
#8.033339 46.625829 9 0 29 LB Grindelwald
#7.892222 46.559444 9 0 29 LT M\374rren
#8.186384 46.728606 9 0 29 LT Meiringen
#8.137778 46.757778 9 0 29 LB Br\374nig
#8.541001 47.379022 9 0 29 LB Z\374rch
8.597777 47.260913 9 0 29 RB Horgen
#8.475556 47.053611 9 0 29 LB Rigi
8.549719 47.048052 9 0 29 LB Goldau
#1860:
#8.475556 47.053611 9 0 29 RB Rigi
#1870:
#7.591127 47.550558 9 0 29 LB Basel
7.537513 47.208331 9 0 29 LT Solothurn
7.533333 47.25 9 0 29 RB Wei\337enstein
7.576113 47.256943 9 0 29 LB G\374nsberg
7.907785 47.35333 9 0 29 LB Olten
#7.591127 47.550558 9 0 29 LB Basel
# von Irene hinzugefügt:
6.916656 46.433334 9 0 29 LB Montreux
7.066654 46.100005 9 0 29 LB Martigny
6.868889 45.922222 9 0 29 LB Chamonix
6.633324 46.516672 9 0 29 LB Lausanne
7.769454 47.349716 9 0 29 RB Langenbruck
8.402785 46.82083 9 0 29 LB Engelberg
6.841936 46.459171 9 0 29 RT Vevey
7.366654 46.233333 9 0 29 LB Sitten/Sion
9.500006 46.999997 9 0 29 RB Bad Ragaz
9.499997 46.983332 9 0 29 RT Pf\344fers
"
echo "$towns" | GMT psxy $common -K -Sc2p -G50  >> $output.ps
echo "$towns" | GMT pstext $common -K -Dj1.5p/1.5p  >> $output.ps
GMT psbasemap $common -Bp --BASEMAP_TYPE=plain >> $output.ps
GMT ps2raster $output.ps -Tf -V -A
rm -f $output.ps

#TODO: 5. Karte gewünscht: 
#Reisen in den Schwarzwald 
#vor 1870: Zürch, Waldshut, Häusern, St. Blasien, Todtmoos, Wiesenthal, Wehr, Schopfheim, Rötteln. Früher: Wehratal.
#1859: Freiburg, Höllental, Titisee. Neustadt (im Schwarzwald), Triberg, Gutach, Kinzigtal, Offenburg. Schapbachertal, Kniebis, Rippoldsau. Ludwigsburg, Freudenstadt. Murgtal. Baden-Baden.
#1866: Rheinbischofsheim.
#1840: Leonberg, Solitüde, Stuttgart, Tübingen, Horb, Freudenstadt, Kniebis, Schapbachertal, Kinzigtal, Ortenberger Schloss, Offenburg, Pforzheim. Konstanz, Donaueschingen, Schaffhausen, Basel, Bad Ragaz, Pfäfers. 30er Donaueschingen, Bodensee. Überlingen.

output=isaak_karte_5
range="-R7.47/10.05/47.5/49.2"
proj="-JM14c"
common="$range $proj -P -V --HISTORY=FALSE"
#GMT makecpt -Csemigray.cpt -Z -T0/4000/100 > height.cpt
GMT grdimage topo/height.grd -Cheight.cpt $common -K > $output.ps
common="$common -O"
GMT pscoast $common -Df -S255 -W.6pt,100 -Ir/.6pt,100 -K >> $output.ps
towns="
# von vorheriger karte kopiert
9.983333 48.4 9 0 29 RB Ulm
9.121389 48.830556 9 0 29 LT Korntal
9.222222 49.141667 9 0 29 LB Heilbronn
8.71 49.412222 9 0 29 LT Heidelberg
8.855 49.103333 9 0 29 RB Sulzfeld
# vor 1870
#8.541001 47.379022 9 0 29 LB Z\374rich
8.214444 47.623056 9 0 29 LB Waldshut
8.169444 47.753889 9 0 29 LB H\344usern
8.128333 47.761944 9 0 29 RB St. Blasien
8.000833 47.739444 9 0 29 LT Todtmoos
7.904167 47.633056 9 0 29 LT Wehr
7.824722 47.649444 9 0 29 RB Schopfheim
7.659531 47.632545 9 0 29 LT R\366tteln
#1859:
7.849881 47.994828 9 0 29 LB Freiburg
8.0294 47.935 9 0 29 LB H\366llental
8.146111 47.893333 9 0 29 LT Titisee
8.214722 47.912222 9 0 29 LM Neustadt
8.231667 48.130833 9 0 29 RB Triberg
8.211667 48.248611 9 0 29 LB Gutach
#7.825 48.610833 9 0 29 LB Kinzigtal
7.940833 48.470833 9 0 29 RB Offenburg
#8.291944 48.377222 9 0 29 LB Schapbachertal
8.293889 48.476389 9 0 29 RB Kniebis
8.291944 48.377222 9 0 29 LT Bad Rippoldsau-Schapbach
9.1922 48.8975 9 0 29 LB Ludwigsburg
8.411111 48.463333 9 0 29 LB Freudenstadt
#8.164722 48.919167 9 0 29 LT Murgtal
8.240833 48.761944 9 0 29 LB Baden-Baden
#1866:
7.934722 48.667778 9 0 29 LB Rheinbischofsheim.
#1840:
9.013056 48.801389 9 0 29 RB Leonberg
9.0843 48.786889 9 0 29 RT Solit\374de
9.1775 48.776111 9 0 29 LT Stuttgart
9.055556 48.52 9 0 29 LB T\374bingen
8.6912 48.4452 9 0 29 LT Horb
#8.411111 48.463333 9 0 29 LB Freudenstadt
#8.293889 48.476389 9 0 29 RB Kniebis
#8.291944 48.377222 9 0 29 LB Bad Rippoldsau-Schapbach
#7.825 48.610833 9 0 29 LB Kinzigtal
7.972883 48.443803 9 0 29 LT Ortenberger Schloss
#7.940833 48.470833 9 0 29 RB Offenburg
8.716667 48.9 9 0 29 LB Pforzheim.
9.175278 47.663333 9 0 29 LB Konstanz
8.503333 47.953056 9 0 29 LB Donaueschingen
8.633333 47.700001 9 0 29 LB Schaffhausen
7.591127 47.550558 9 0 29 LB Basel
#8.503333 47.953056 9 0 29 LB Donaueschingen
9.366667 47.633333 9 0 29 LT Bodensee
9.158333 47.766667 9 0 29 LB \334berlingen

7.897778 47.654444 9 0 29 LB Hasel
8.421389 48.138333 9 0 29 LB K\366nigsfeld

"
echo "$towns" | GMT psxy $common -K -Sc2p -G50  >> $output.ps
echo "$towns" | GMT pstext $common -K -Dj1.5p/1.5p  >> $output.ps
GMT psbasemap $common -Bp --BASEMAP_TYPE=plain >> $output.ps
GMT ps2raster $output.ps -Tf -V -A
rm -f $output.ps


# Weltkarten
output=welt
range="-R-130/150/-60/75"
proj="-JN14c"
common="$range $proj -P --ELLIPSOID=Sphere -V --HISTORY=FALSE"
GMT grdimage -K topo/world.grd -Cheight.cpt $common > $output.ps
common="$common -O"
GMT pscoast -K $common -Dl -N1/.6pt,100 -W.6pt,100 -A20000 >> $output.ps
# PDF ohne Daten für schnelle Vorschau
cat $output.ps > $output-tmp.ps
GMT psbasemap $common -Bp --BASEMAP_TYPE=plain >> $output-tmp.ps
GMT ps2raster $output-tmp.ps -Tf -V -A
mv $output-tmp.pdf $output.pdf
rm -f $output.tmp.ps

output=deutschland
range="-R5/15.5/46.8/55"
proj="-JB10/50/45/55/14c"
common="$range $proj -P --HISTORY=FALSE"
GMT grdimage -K topo/world.grd -Cheight.cpt $common > $output.ps
common="$common -O"
GMT pscoast -K $common "-Dh" "-N1/.6pt,100" "-W.6pt,100" "-A0/0/1" "-I1/." >> $output.ps
# PDF ohne Daten für schnelle Vorschau
cat $output.ps > $output-tmp.ps
GMT psbasemap $common -Bp --BASEMAP_TYPE=plain >> $output-tmp.ps
GMT ps2raster $output-tmp.ps -Tf -V -A
mv $output-tmp.pdf $output.pdf
rm -f $output.tmp.ps

output=europa
range="-R-12/24/46/60"
proj="-JB6/50/45/55/14c"
common="$range $proj -P --HISTORY=FALSE"
GMT grdimage -K topo/world.grd -Cheight.cpt $common > $output.ps
common="$common -O"
GMT pscoast -K $common "-Dh" "-N1/.6pt,100" "-W.6pt,100" "-A0/0/1" "-I1/." >> $output.ps
# PDF ohne Daten für schnelle Vorschau
cat $output.ps > $output-tmp.ps
GMT psbasemap $common -Bp --BASEMAP_TYPE=plain >> $output-tmp.ps
GMT ps2raster $output-tmp.ps -Tf -V -A
mv $output-tmp.pdf $output.pdf
rm -f $output.tmp.ps
