#!/usr/bin/python
# encoding:UTF-8

import os
import sys

import cgi
import cgitb; cgitb.enable(1,'/tmp/fragebogen-log/')
import Cookie

from Cheetah.Template import Template
from Cheetah.Filters import Filter

import email.Utils
from email.MIMEText import MIMEText
from email.MIMEMultipart import MIMEMultipart
from email.Message import Message
from email.Header import Header
email.Charset.add_charset( 'utf-8', email.Charset.QP, email.Charset.QP, None )
#email.Charset.add_charset( 'myutf8', email.Charset.QP, email.Charset.QP, None )

#from subprocess import Popen,PIPE
import smtplib


def esc(str):
    if str:
        return cgi.escape(str, True)
    else:
        return ""

class RawOrEncodedUnicode(Filter):
    '''
    Pass Unicode strings through unmolested, unless an encoding is specified.
    '''
    def filter(self, val, encoding=None, **kw):
        if isinstance(val, unicode):
                if encoding:
                    filtered = val.encode(encoding)
                else:
                    filtered = val
        elif val is None:
                filtered = ''
        else:
                filtered = str(val)
        return filtered

class Form(cgi.FieldStorage):
    def getfirst(self, key, default=None):
        """ Return the first value received."""
        if key in self:
            value = cgi.FieldStorage.__getitem__(self,key)
            if type(value) is type([]):
                return value[0].value
            else:
                return value.value
        else:
            return default

    def get(self, key, default=None):
        encoding = self.getfirst('_charset_') or 'UTF-8'
        if key in self:
            value = cgi.FieldStorage.__getitem__(self,key)
            if type(value) is type([]):
                return value[0].value.decode(encoding)
            else:
                return value.value.decode(encoding)
        else:
            return default

    __getitem__ = get

pretty = {
    'nachname':    u'Nachname:         ',
    'vorname':     u'Vorname:          ',
    'title':       u'Titel:            ',
    'gebdat':      u'Geburtsdatum:     ',
    'gebort':      u'Geburtsort:       ',
    'sterbdat':    u'Sterbedatum:      ',
    'sterbort':    u'Sterbeort:        ',
#    'kurzbio':  'Kurzbiographie',
    'heiratdat':   u'Heiratsdatum:     ',
    'heiratort':   u'Heiratsort:       ',
    'bemerkung':   u'Bemerkung:        ',
    'muttername':  u'Name d.M.:        ',
    'muttergebdat':u'Geburtsdatum d.M.:',
    'muttergebort':u'Geburtsort d.M.:  ',
    'vatername':   u'Name d.V.:        ',
    'vatergebdat': u'Geburtsdatum d.V.:',
    'vatergebort': u'Geburtsort d.V.:  ',
    'adresse':     u'Adresse:          ',
    'email':       u'e-Mail:           ',
    'bvoe':        u'Veröffent. Buch:  ',
    'ovoe':        u'Veröffent. online:',
    'bint':        u'Interesse am Buch:',
    'addrle':      u'Adressliste Erh.: ',
    'addrla':      u'Adressliste Aufn.:',
}

def main():
    form = Form()

    if 'mail_body' in form:
        confirm_mail(form)
    else:
        formulate_mail(form)

def formulate_mail(form):
    cookie = Cookie.SimpleCookie(os.environ.get('HTTP_COOKIE',''))

    bemerkung = '--keine--'
    if 'bemerkung' in form:
        bemerkung = form['bemerkung']

    assert 'num' in form
    num = form['num']

    name = u"%s %s" % (form.get('vorname','--'),form.get('nachname','--'))
    subject = u"[%s] %s" % (num, name)

    field_names = filter(lambda k: not k.endswith("_old"), form.keys())

    changed_fields = {}
    for field in field_names:
        old = field + '_old'
        if old not in form:
            changed_fields[field] = (None,form[field])
        elif form[field] != form[old]:
            changed_fields[field] = (form[old],form[field])
   
    changes = u""

    changes += u"Änderungen am den Hauptdaten von %s\n" % name
    changed = False
    for field in ['vorname','nachname','title','gebdat','gebort','sterbdat','sterbort']:
        if field in changed_fields:
            changed = True
            (old,new) = changed_fields[field]
            if old:
                changes += u"    %s %s (war: %s)\n" % (pretty[field],new,old)
            else:
                changes += u"    %s %s (neu)\n" % (pretty[field],new)
    if 'kurzbio' in changed_fields:
        changed = True
        (old,new) = changed_fields['kurzbio']
        if old:
            changes+= u"    Kurzbiographie geändert zu:\n===========\n"+ new + u"\n===========\n" 
        else:
            changes+= u"    Kurzbiographie hinzugefügt:\n===========\n"+ new + u"\n===========\n" 
    if not changed:
        changes += u"--keine--\n"


    changes += '\n'

    n = 1
    part = "part%d" % n
    while part+'nachname' in form or part+'vorname' in form:
        changes += u"Änderung am Partner %s %s\n" % (form.get(part+'nachname','--'), form.get(part+'vorname','--'))
        changed = False
        for field in ['vorname','nachname','title','gebdat','gebort',
                      'heiratdat','heiratort','sterbdat','sterbort',
                      'vatername','vatergebdat','vatergebort', 'muttername','muttergebdat','muttergebort',]:
            pfield = part+field
            if pfield in changed_fields:
                changed = True
                (old,new) = changed_fields[pfield]
                if old:
                    changes += u"    %s %s (war: %s)\n" % (pretty[field],new,old)
                else:
                    changes += u"    %s %s (neu)\n" % (pretty[field],new)
        if part+'kurzbio' in changed_fields:
            changed = True
            (old,new) = changed_fields[part+'kurzbio']
            if old:
                changes+= u"    Kurzbiographie geändert zu:\n===========\n"+ new + u"\n===========\n" 
            else:
                changes+= u"    Kurzbiographie hinzugefügt:\n===========\n"+ new + u"\n===========\n" 
        n += 1
        part = "part%d" % n
        if not changed:
            changes += u"--keine--\n"

    changes += '\n'

    n = 1
    kind = "kind%d" % n
    while kind+'nachname' in form or kind+'vorname' in form:
        changes += u"Änderung am Kind %d: %s %s\n" % (n,form.get(kind+'nachname','--'), form.get(kind+'vorname','--'))
        changed = False
        for field in ['vorname','nachname','title','gebdat','gebort','sterbdat','sterbort','bemerkung']:
            kfield = kind+field
            if kfield in changed_fields:
                changed = True
                (old,new) = changed_fields[kfield]
                if old:
                    changes += u"    %s %s (war: %s)\n" % (pretty[field],new,old)
                else:
                    changes += u"    %s %s (neu)\n" % (pretty[field],new)
        n += 1
        kind = "kind%d" % n
        if not changed:
            changes += u"--keine--\n"

    changes += '\n'

    if not form.get('sterbdat',''):
        # Nur für lebende diese Felder verarbeiten
        changes += u"Änderungen an den sonstigen Daten:\n"
        changed = False
        if 'adresse' in changed_fields:
            changed = True
            (old,new) = changed_fields['adresse']
            if old:
                changes+= u"    Adresse geändert zu:\n===========\n"+ new + u"\n===========\n" 
            else:
                changes+= u"    Adresse hinzugefügt:\n===========\n"+ new + u"\n===========\n" 
        if 'email' in changed_fields:
            changed = True
            (old,new) = changed_fields['email']
            if old:
                changes += u"    %s %s (war: %s)\n" % (pretty['email'],new,old)
            else:
                changes += u"    %s %s (neu)\n" % (pretty['email'],new)
        for field in ['bvoe','ovoe','bint','addrla','addrle']:
            if field in changed_fields:
                changed = True
                (old,new) = changed_fields[field]
                if old:
                    changes += u"    %s %s (war: %s)\n" % (pretty[field],new,old)
                else:
                    changes += u"    %s %s (neu)\n" % (pretty[field],new)

    if not changed:
        changes += u"--keine--\n"


    user = ''
    if 'user' in cookie:
        user = cookie['user'].value.decode("utf-8")
    user_email = ''
    if 'user_email' in cookie:
        user_email = cookie['user_email'].value.decode("utf-8")

    sys.stdout.write('Content-type: text/html\n\n')
    vars =  {'subject':esc(subject), 'text': esc(changes), 'name':esc(name),
            'user':esc(user), 'user_email':esc(user_email), 'bemerkung':esc(bemerkung)}
    vars['message'] = esc(changes) #messageTemplate(vars)
    t =  checkTemplate(vars)
    sys.stdout.write(t.respond().encode('utf-8'))


def messageTemplate(dict):
    return Template(u'''
#encoding UTF-8
$text
''',[dict])

def checkTemplate(dict):
    return Template(u'''<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<title>Fragebogen zu $subject</title>
</head>
<body>
<h1>Fragebogen zu $subject</h1>
<form action="" method="post">
<h3>Wer sind sie?</h3>
<p>F&uuml;r R&uuml;ckfragen bitte diese Felder ausf&uuml;llen:</p>
<dl>
<dt>Ihr Name:</dt><dd><input type="text" name="user" value="$user" width="50"/></dd>
<dt>Ihre e-Mail-Adresse:</dt><dd><input type="text" name="user_email" value="$user_email" width="50"/></dd>
</dl>

<h3>Eingabe-Kontrolle</h3>
<p>Die folgende Nachricht wird an das Isaak-Buch-Team geschickt. Sie k&ouml;nnen sie noch einmal kontrollieren und gegebenenfalls korrigieren.</p>
<input type="hidden" name="subject" value="$subject"/>
<input type="submit" value="Absenden"/><br/>
<textarea name="mail_body" rows="100" cols="80">
Hallo Isaak-Buch-Team,

es gibt neue Daten zu:
$name

Anmerkungen:
$bemerkung

$message
</textarea>
<br/>
<input type="submit" value="Absenden"/>
</form>
</body>
</html>''',searchList=[dict],filter=RawOrEncodedUnicode)


def confirm_mail(form):
    cookie = Cookie.SimpleCookie(os.environ.get('HTTP_COOKIE',''))

    body = form['mail_body']
    subject = form['subject']
    user = form['user']
    user_email = form['user_email']

    if user:
        cookie['user'] = user.encode("utf-8")
        cookie['user']['expires'] = 123499990
    if user_email:
        cookie['user_email'] = user_email.encode("utf-8")
        cookie['user_email']['expires'] = 123499990

    to_addr = "removed@from.codedump"

    to = Header()
    to.append(u"Isaak-Buch-Team")
    to.append("<%s>" % to_addr)
    other = Header()
    other.append(user)
    other.append("<%s>" % user_email)

    msg = MIMEText(body.encode("utf8"), _charset="utf-8")
    #msg = MIMEMultipart()
    msg['Subject'] = Header(subject)
    msg['To'] = to
    msg['CC'] = other
    msg['From'] = other
    msg['Date'] = Header(email.Utils.formatdate())
    #msg.set_payload(body)
    #msg.attach(MIMEText(body.encode('utf-8'), _charset="utf-8"))

    error = None
    hint = None

    if not user_email:
        error = u"no e-mail address"
        hint = u"Bitte geben Sie ihre e-Mail-Adresse an"
    else:
        try:
            server = smtplib.SMTP('localhost')
            #server.set_debuglevel(1)
            server.sendmail(to_addr, [to_addr, user_email], msg.as_string())
            server.quit()
        except smtplib.SMTPException, e:
            error = str(e)
            hint = u"Es gab ein Problem mit der e-Mail-Kommunikation. Bitte überprüfen sie die angegebene e-Mail-Adresse, %s, und versuchen sie es erneut." % user_email

    if error:
        vars =  {'hint':esc(hint), 'error':esc(error) ,'subject':esc(subject), 'user':esc(user), 'user_email':esc(user_email) }
        t =  errorTemplate(vars)
        sys.stdout.write(cookie.output())
        sys.stdout.write('\nContent-type: text/html\n\n')
        sys.stdout.write(t.respond().encode('utf8'))

    else:
        vars =  {'body':esc(body), 'subject':esc(subject), 'user':esc(user), 'user_email':esc(user_email) }
        t =  confirmTemplate(vars)
        sys.stdout.write(cookie.output())
        sys.stdout.write('\nContent-type: text/html\n\n')
        sys.stdout.write(t.respond().encode('utf8'))

def errorTemplate(dict):
    return Template(u'''<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<title>Fehlermeldung ($subject)</title>
</head>
<body>
<h1>Fehlermeldung ($subject)</h1>
<p>
Es ist ein Fehler aufgetreten. Die Beschreibung ist:
</p>
<p style="font-weight:bold">$hint</p>
<p>Sollten Sie damit nicht weiterkommen, so wenden Sie sich an Joachim Breitner (<a href="mailto:mail@joachim-breitner.de">mail@joachim-breitner.de</a>). Bitte geben Sie dabei folgende Information mit:</p>
<pre>$error</pre>
</body>
</html>''',searchList=[dict],filter=RawOrEncodedUnicode)

def confirmTemplate(dict):
    return Template(u'''<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<title>Fragebogen absenden ($subject)</title>
</head>
<body>
<h1>Fragebogen absenden ($subject)</h1>
<p>$user, danke f&uuml;r deinen Beitrag. Diese Nachricht wurde dem Isaak-Buch-Team geschickt und eine Kopie ging an $user_email:</p>
<p><a href=".">Zur&uuml;ck zu den Frageb&ouml;gen</a></p>
<pre>
$body
</pre>
</body>
</html>''',searchList=[dict],filter=RawOrEncodedUnicode)


main()

# vim:ts=4:sw=4:expandtab:smarttab
